最新消息:

Python 3语法小记(九) 异常 Exception

python 3 永恒心锁 1301浏览 0评论

常见异常:
Exception 所有异常的基类
AttributeError 特性应用或赋值失败时引发
IOError 试图打开不存在的文件时引发
IndexError 在使用序列中不存在的索引时引发
KeyError 在使用映射不存在的键时引发
NameError 在找不到名字(变量)时引发
SyntaxError 在代码为错误形式时引发
TypeError 在内建操作或者函数应用于错误类型的对象是引发
ValueError 在内建操作或者函数应用于正确类型的对象,但是该对象使用不合适的值时引发
ZeroDivisionError 在除法或者摸除操作的第二个参数为0时引发

自定义异常:
继承于 Exception 的类

class myException(Exception):pass

抛出异常:
raise 语句

>> def division(x,y):
if y == 0 :
raise ZeroDivisionError(‘The zero is not allow’)
return x/y

>>> try:
division(1,0)
except ZeroDivisionError as e:
print(e)

The zero is not allow

捕捉异常:
可同时捕捉多个异常,可捕捉异常对象,可忽略异常类型以捕捉所有异常

>> try:
x = int(input(‘input x:’))
y = int(input(‘input y:’))
print(‘x/y = ‘,x/y)
except ZeroDivisionError: #捕捉除0异常
print(“ZeroDivision”)
except (TypeError,ValueError) as e: #捕捉多个异常,并将异常对象输出
print(e)
except: #捕捉其余类型异常
print(“it’s still wrong”)

input x:12
input y:0
ZeroDivision
>>> try:
x = int(input(‘input x:’))
y = int(input(‘input y:’))
print(‘x/y = ‘,x/y)
except ZeroDivisionError: #捕捉除0异常
print(“ZeroDivision”)
except (TypeError,ValueError) as e: #捕捉多个异常,并将异常对象输出
print(e)
except: #捕捉其余类型异常
print(“it’s still wrong”)

input x:12
input y:y
invalid literal for int() with base 10: ‘y’

try/except 可以加上 else 语句,实现在没有异常时执行什么

>> try:
x = int(input(‘input x:’))
y = int(input(‘input y:’))
print(‘x/y = ‘,x/y)
except ZeroDivisionError: #捕捉除0异常
print(“ZeroDivision”)
except (TypeError,ValueError) as e: #捕捉多个异常
print(e)
except: #捕捉其余类型异常
print(“it’s still wrong”)
else: #没有异常时执行
print(‘it work well’)

input x:12
input y:3
x/y = 4.0
it work well

finally 语句
不管是否出现异常,最后都会执行finally的语句块内容,用于清理工作
所以,你可以在 finally 语句中关闭文件,这样就确保了文件能正常关闭

>> try:
x = int(input(‘input x:’))
y = int(input(‘input y:’))
print(‘x/y = ‘,x/y)
except ZeroDivisionError: #捕捉除0异常
print(“ZeroDivision”)
except (TypeError,ValueError) as e: #捕捉多个异常
print(e)
except: #捕捉其余类型异常
print(“it’s still wrong”)
else: #没有异常时执行
print(‘it work well’)
finally: #不管是否有异常都会执行
print(“Cleaning up”)

input x:12
input y:3
x/y = 4.0
it work well
Cleaning up

异常抛出之后,如果没有被接收,那么程序会抛给它的上一层,比如函数调用的地方,要是还是没有接收,那继续抛出,如果程序最后都没有处理这个异常,那它就丢给操作系统了 — 你的程序崩溃了,这点和C++一样的。

永恒心锁,版权所有丨如未注明,均为转载丨本网站采用BY-NC-SA协议进行授权

转载请注明:永恒心锁-分享互联网 » Python 3语法小记(九) 异常 Exception

您必须 登录 才能发表评论!